mainApp/urls.py
from django.contrib import admin
from django.urls import path

from .views import film
from .views import actor
from .views import director
from .views import country
from . import main_views

urlpatterns = [
    path('', main_views.home),

    # baseLayout test route
    path('baseLayout/', main_views.baseLayout),

    # film routes
    path('film/', film.getList),
    path('film/add/', film.add),
    path('film/update/<id>', film.update),
    path('film/delete/<id>', film.delete),
    path('film/details/<id>', film.details),

    # actor routes
    path('actor/', actor.getList),
    path('actor/add/', actor.add),
    path('actor/update/<id>', actor.update),
    path('actor/delete/<id>', actor.delete),
    path('actor/details/<id>', actor.details),

    # director routes
    path('director/', director.getList),
    path('director/add/', director.add),
    path('director/update/<id>', director.update),
    path('director/delete/<id>', director.delete),
    path('director/details/<id>', director.details),

    # country routes
    path('country/', country.getList),
    path('country/add/', country.add),
    path('country/delete/<id>', country.delete),
    path('country/details/<id>', country.details),
]

projetFilm/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('main/', include('mainApp.urls'))

]

handler404 = 'mainApp.main_views.not_found'

mainApp/models.py
from django.db import models

class Country(models.Model):
    code = models.CharField(max_length=25)
    libelle = models.CharField(max_length=50)

    def __str__(self):
        return self.libelle

class Director(models.Model):
    firstName = models.CharField(max_length=250)
    lastName = models.CharField(max_length=250, null=True)
    bornDate = models.DateField(null=True)
    bio = models.TextField()
    country = models.ForeignKey(Country, on_delete=models.CASCADE)
    pathImg = models.TextField(null=True)

    def __str__(self):
        return self.firstName

class Film(models.Model):
    name = models.CharField(max_length=250)
    originalName = models.CharField(max_length=250, null=True)
    description = models.TextField()
    duration = models.CharField(max_length=250, null=True)
    public = models.CharField(max_length=250, null=True)
    releaseDate = models.CharField(max_length=250, null=True)
    rating = models.FloatField(null=True)
    director = models.ForeignKey(Director, on_delete=models.CASCADE, null=True)
    pathImg = models.TextField(null=True)

    def __str__(self):
        return self.name

class Actor(models.Model):
    firstName = models.CharField(max_length=250)
    lastName = models.CharField(max_length=250, null=True)
    bornDate = models.DateField(null=True)
    bio = models.TextField()
    country = models.ForeignKey(Country, on_delete=models.CASCADE)
    films = models.ManyToManyField(Film)
    pathImg = models.TextField(null=True)

    def __str__(self):
        return self.firstName

class Genre(models.Model):
    name = models.CharField(max_length=250)
    films = models.ManyToManyField(Film)

mainApp/views/actor.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.forms import ModelForm
from ..models import Actor
from django.urls import reverse
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from ..models import Film

class ActorForm(ModelForm):
    class Meta:
        model = Actor
        fields = ('firstName', 'lastName', 'bornDate', 'bio', 'country', 'films', 'pathImg')

topTenFilm = Film.objects.order_by('-rating')[:10]
lastTenFilm = Film.objects.order_by('-releaseDate')[:10]

def add(request):
    form = ActorForm()
    if request.method == "POST":
        form = ActorForm(request.POST)
        if form.is_valid():
            new_actor = form.save()
            return render(request, template_name='actor/list_display.html', context={'actor': new_actor} )
    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'actor/actor_form.html', context)

def update(request, id):
    actor = Actor.objects.get(pk=id)
    if request.method == "POST":
        form = ActorForm(request.POST, instance=actor)
        if form.is_valid():
            form.save()
            return render(request, template_name='main_app/index_ex.html', context={'actor': id} )
    form = ActorForm(instance=actor)
    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'actor/actor_form.html', context)

def delete(request, id):
    actor = Actor.objects.get(pk=id)
    actor.delete()
    return HttpResponse('delete actor') #TODO define delete response

def details(request, id):
    actor = Actor.objects.get(pk=id)
    films = actor.films.all()
    return render(request, template_name='actor/actor.html', context={'actor': actor, 'films': films, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

def getList(request):
    actor_list = Actor.objects.all()
    paginator = Paginator(actor_list, 10)

    page = request.GET.get('page')
    actors = paginator.get_page(page)
    return render(request, template_name='actor/list_display.html', context={'objects': actors, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

mainApp/views/country.py
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.forms import ModelForm
from ..models import Country
from django.urls import reverse

class CountryForm(ModelForm):
    class Meta:
        model = Country
        fields = ('code', 'libelle')

def add(request):
    form = CountryForm()
    if request.method == "POST":
        form = CountryForm(request.POST)
        if form.is_valid():
            new_country = form.save()
            return render(request, template_name='country/list_display.html', context={'country': new_country} )
    context = {'form': form}
    return render(request,'country/country_form.html', context)

def update(self):
    return HttpResponse('update country')

def delete(self, id):
    country = Country.objects.get(pk=id)
    country.delete()
    return HttpResponse('delete country') #TODO define delete response

def details(self, id):
    country = Country.objects.get(pk=id)
    return render(self, template_name='country/country.html', context={'country': country} )

def getList(request):
    countries = Country.objects.all().order_by('id')
    return render(request, template_name='country/list_display.html', context={'objects': countries} )

mainApp/views/director.py
from django.shortcuts import render
from django.http import HttpResponse
from ..models import Director
from django.forms import ModelForm
from ..models import Film
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator

class DirectorForm(ModelForm):
    class Meta:
        model = Director
        fields = ('firstName', 'lastName', 'bornDate', 'bio', 'country', 'pathImg')

topTenFilm = Film.objects.order_by('-rating')[:10]
lastTenFilm = Film.objects.order_by('-releaseDate')[:10]

def add(request):
    form = DirectorForm()
    if request.method == "POST":
        form = DirectorForm(request.POST)
        if form.is_valid():
            new_director = form.save()
            return render(request, template_name='director/list_display.html', context={'director': new_director} )
    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'director/director_form.html', context)

def update(request, id):
    director = Director.objects.get(pk=id)
    if request.method == "POST":
        form = DirectorForm(request.POST, instance=director)
        if form.is_valid():
            form.save()
            return render(request, template_name='main_app/index_ex.html', context={'director': id} )
    form = DirectorForm(instance=director)
    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'director/director_form.html', context)

def delete(self, id):
    director = Director.objects.get(pk=id)
    director.delete()
    return HttpResponse('delete director') #TODO define delete response

def details(request, id):
    director = Director.objects.get(pk=id)
    return render(request, template_name='director/director.html', context={'director': director, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

def getList(request):
    director_list = Director.objects.all()
    paginator = Paginator(director_list, 10)

    page = request.GET.get('page')
    directors = paginator.get_page(page)
    return render(request, template_name='director/list_display.html', context={'objects': directors, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

mainApp/views/film.py
from django.shortcuts import render
from django.http import HttpResponse
from ..models import Film
from django.forms import ModelForm
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from ..filmFilter import FilmFilter

class FilmForm(ModelForm):
    class Meta:
        model = Film
        fields = ('name', 'originalName',
        'description', 'duration', 'public',
        'releaseDate', 'rating', 'director', 'pathImg')

topTenFilm = Film.objects.order_by('-rating')[:10]
lastTenFilm = Film.objects.order_by('-releaseDate')[:10]

def add(request):
    form = FilmForm()
    if request.method == "POST":
        form = FilmForm(request.POST)
        if form.is_valid():
            new_film = form.save()
            film = new_film
            actors = film.actor_set.all()
            return render(request, template_name='film/film.html', context={'film': film, 'actors': actors, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'film/film_form.html', context)

def update(request, id):
    film = Film.objects.get(pk=id)
    if request.method == "POST":
        form = FilmForm(request.POST, instance=film)
        if form.is_valid():
            form.save()
            return render(request, template_name='film/list_display.html')
    form = FilmForm(instance=film)
    context = {'form': form, 'topTen': topTenFilm, 'lastTen': lastTenFilm}
    return render(request,'film/film_form.html', context)

def delete(request, id):
    film = Film.objects.get(pk=id)
    film.delete()
    return HttpResponse('delete film') #TODO define delete response

def details(request, id):
    film = Film.objects.get(pk=id)
    actors = film.actor_set.all()
    return render(request, template_name='film/film.html', context={'film': film, 'actors': actors, 'topTen': topTenFilm, 'lastTen': lastTenFilm} )

def getList(request):
    filmList = []

    resFilter = filterFilmsByName(request)
    filmList = resFilter[0]
    searchMsg = resFilter[1]
    searchTerm = resFilter[2]

    if len(filmList) == 0:
        filmList = Film.objects.all()

    paginator = Paginator(filmList, 10)
    page = request.GET.get('page')

    films = paginator.get_page(page)
    return render(request, template_name='film/list_display.html', context={'objects': films, 'topTen': topTenFilm, 'lastTen': lastTenFilm, 'searchMsg' : searchMsg, 'searchTerm': searchTerm} )

def filterFilmsByName(rq):
    filteredList = []
    message = ""
    if rq.GET.get('name'):
        filteredList = Film.objects.filter(name__contains=rq.GET.get('name'))
        if len(filteredList) == 0:
            message = "No movies were found for this name"
    return [filteredList, message, rq.GET.get('name')]

mainApp/templates/actor/actor.html
{% extends "baseLayout.html" %}
{% load static %}

{% block body %}
{% include "includes/sidebar-left.html" %}
<div class="float-left bg-light content">
  <div class="container-fliud">
    <div class="wrapper row m-5">
      <div class="col-md-4">
        <img src="{{ actor.pathImg }}" class="img-thumbnail"  alt="{{ actor.name }} movie poster"/>
      </div>
      <div class="details col-md-6">
        <h1 class="actor-title mb-3 mt-3 d-inline">{{ actor.firstName }} {{ actor.lastName }}</h1>
        <h4 class="d-inline ml-2"><span class="text-secondary">({{ actor.bornDate|date:"d/m/Y" }})</span></h4>
        <hr />
        <h4>Biography</h4>
        <p class="film-description ml-3">{{ actor.bio }}<p>
      </div>
    </div>
    <div class="down-bar-container">
      <div class="row ml-1">
        <h4>Filmography</h4>
      </div>
      <hr />
      <div class="d-flex flex-wrap justify-content-center">
        {% for film in films %}
        <a class="link-block" href="/main/film/details/{{film.id}}">
          <div class="card m-2" style="">
            <img class="card-img-top img-mdm-thumbnail" src="{{film.pathImg}}" alt="Card image cap">
            <div class="card-body">
              <h6 class="card-text text-center">{{ film.name }}</h6>
            </div>
          </div>
        </a>
        {% endfor %}
      </div>
    </div>
  </div>
</div>
{% include "includes/sidebar-right.html" %}
{% endblock %}

mainApp/templates/actor/actor_form.html
{% extends "baseLayout.html" %}
{% load static %}

{% block body %}
{% include "includes/sidebar-left.html" %}
<div class="bg-light content">
  <div class="page-header mt-5 ml-5">
    {% if form.firstName.value %}
    <h1>Edit Actor</h1>
    {% else %}
    <h1>New Actor</h1>
    {% endif %}
  </div>
  {% include "includes/form-errors.html" %}
  <form class="p-5" action="" method="POST">
    {% csrf_token %}

    <label for="lastName" class="col-2 col-form-label">Name</label>
    <input class="form-control" type="text" value="{{ form.lastName.value|default_if_none:"" }}" name="lastName" id="id_lastName">

    <label for="firstName" class="col-2 col-form-label">First Name</label>
    <input class="form-control" type="text" value="{{ form.firstName.value|default_if_none:"" }}" name="firstName" id="id_firstName">

    <label for="pathImg" class="col-2 col-form-label">Image</label>
    <input class="form-control" type="text" value="{{ form.pathImg.value|default_if_none:"" }}" name="pathImg" id="id_pathImg">

    <label for="bornDate" class="col-2 col-form-label">Born</label>
    <input class="form-control" type="date" value="{{ form.bornDate.value|date:"Y-m-d" }}" name="bornDate" id="id_bornDate">

    <label for="bio" class="col-2 col-form-label">Biography</label>
    <textarea class="form-control" name="bio" rows="10" cols="50">{{ form.bio.value|default_if_none:"" }}</textarea>

    <label for="country" class="col-2 col-form-label">Country</label>
    <select class="form-control" id="id_country" name="country">
      {% for c in form.country %}
      {{ c }}
      {% endfor %}
    </select>
    <label for="films" class="col-2 col-form-label">Films</label>
    <select class="form-control" name="films" required="" id="id_films" multiple="">
      {% for f in form.films %}
      {{ f }}
      {% endfor %}
    </select>
    <input class="btn btn-primary m-3" type="submit" value="Save"/>
  </form>
</div>
{% include "includes/sidebar-right.html" %}

{% endblock %}

mainApp/templates/actor/list_display.html
{% extends "baseLayout.html" %}
{% load static %}

{% block body %}
{% include "includes/sidebar-left.html" %}
<div class="bg-light content">
  <div class="page-header m-5">
    <h1>Best Actors</h1>
  </div>
  {% include "includes/pagination.html" %}
  <table class="table table-hover table-sm table-borderless">
    <thead class="thead-dark">
        <tr>
            <th scope="col"></th>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
            <th scope="col">Birth date</th>
            <th scope="col">Country</th>
            <th scope="col"></th>
        </tr>
    </thead>
    <tbody>
        {% for obj in objects %}
        <tr>
            <td><img class="img-sml-thumbnail" src="{{obj.pathImg}}" alt="{{obj.firstName}} {{obj.lastName}}"/></td>
            <td class="align-middle">{{obj.firstName}}</td>
            <td class="align-middle">{{obj.lastName}}</td>
            <td class="align-middle">{{ obj.bornDate }}</td>
            <td class="align-middle">{{ obj.country.libelle }}</td>
            <td class="align-middle"><a href="/main/actor/details/{{obj.id}}"><h3><span class="oi oi-eye"></span></h3></td>
        </tr>
        {% endfor %}
    </tbody>
  </table>
  {% include "includes/pagination.html" %}
</div>
{% include "includes/sidebar-right.html" %}
{% endblock %}